;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; Mouser, by Dispari Scuro, modified by imamelia
;
; This is Mouser from SMB2.
;
; Extra bytes: 1
;
; Bits 0-2: Hitpoint count.
; Bit 3: Which palette Mouser uses.  (0 -> palette E, 1 -> palette F.)
; Bits 4-7: Index to throw tables.
;
; Sprite table info:
;
; $1504,x - throw timer
; $1528,x - HP
; $1564,x - invulnerability timer
; $163E,x - jump timer
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

incsrc subroutinedefs.asm

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; defines and tables
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

; Bits 0-9 - sprite number
; Bits 10-14 - unused
; Bit 15 - throw a custom sprite
SpriteToThrow:
	dw $81B5,$81B2,$000D,$0000,$0000,$0000,$0000,$0000
	dw $0000,$0000,$0000,$0000,$0000,$0000,$0000,$0000
; $14C8,x
SpawnStatus:
	db $09,$08,$09,$08,$08,$08,$08,$08
	db $08,$08,$08,$08,$08,$08,$08,$08
; $B6,x
SpawnXSpeed:
	db $18,$18,$18,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
; $AA,x
SpawnYSpeed:
	db $C0,$C0,$C0,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
; $C2,x
SpawnState1:
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
; $1510,x
SpawnState2:
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
; $1540,x
SpawnTimer1:
	db $00,$00,$A0,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
; $1504,x
SpawnTimer2:
	db $FF,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
; $7FAB40,x
SpawnExByte1:
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
; $7FAB4C,x
SpawnExByte2:
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
; $7FAB58,x
SpawnExByte3:
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
; $7FAB64,x
SpawnExByte4:
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

; which tile to show when throwing
TilesToShow:
	db $CE,$64,$CA,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
; tile properties of said tile (left, right)
TilePropShow1:
	db $0D,$07,$07,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
TilePropShow2:
	db $0D,$07,$47,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
ProjectileOffset:
	db $F9,$0F

SpawnXOffsetLo:
	db $F9,$0F
SpawnXOffsetHi:
	db $FF,$00

!TimeToShow = $20
!TimeTillThrow = $68

XSpeed:
	db $00,$F0,$00,$10
TimeInPos:
	db $37,$18,$37,$18

HorizDisp:
	db $00,$08,$00,$08
	db $00,$08,$00,$08
	db $00,$08,$00,$08
	db $00,$08,$00,$08
	db $00,$08,$00,$08
	db $08,$00,$08,$00
	db $00,$08,$00,$08
	db $00,$08,$00,$08
	db $08,$00,$08,$00
	db $08,$00,$08,$00
	db $08,$00,$08,$00
	db $08,$00,$08,$00
	db $08,$00,$08,$00
	db $00,$08,$00,$08
	db $08,$00,$08,$00
	db $08,$00,$08,$00
VertDisp:
	db $F0,$F0,$00,$00
	db $EF,$EF,$FF,$FF
	db $F0,$F0,$FF,$FF
	db $F0,$F0,$FF,$FF
	db $F0,$F0,$00,$00
	db $F0,$F0,$00,$00
	db $00,$00,$F0,$F0
	db $00,$00,$F0,$F0
	db $F0,$F0,$00,$00
	db $EF,$EF,$FF,$FF
	db $F0,$F0,$FF,$FF
	db $F0,$F0,$FF,$FF
	db $F0,$F0,$00,$00
	db $F0,$F0,$00,$00
	db $00,$00,$F0,$F0
	db $00,$00,$F0,$F0
Tilemap:
	db $C0,$C1,$E0,$E1		; walk 1: head left, head right, bottom left, bottom right
	db $C0,$C1,$E6,$E7		; walk 2: head left, head right, bottom left, bottom right
	db $C0,$C1,$E9,$EA		; throw1: head left, head right, bottom left, bottom right
	db $C0,$C1,$E9,$EA		; throw2: head left, head right, bottom left, bottom right
	db $C3,$C4,$E3,$E4		; hurt 1: head left, head right, bottom left, bottom right
	db $C3,$C4,$E3,$E4		; hurt 2: head left, head right, bottom left, bottom right
	db $C3,$C4,$E3,$E4		; dying : head left, head right, bottom left, bottom right
	db $C3,$C4,$E3,$E4		; dying2: head left, head right, bottom left, bottom right
	db $C0,$C1,$E0,$E1
	db $C0,$C1,$E6,$E7
	db $C0,$C1,$E9,$EA
	db $C0,$C1,$E9,$EA
	db $C3,$C4,$E3,$E4
	db $C3,$C4,$E3,$E4
	db $C3,$C4,$E3,$E4
	db $C3,$C4,$E3,$E4
	
TileProps:
	db $00,$00,$00,$00		; 00 = no flip
	db $00,$00,$00,$00		; 40 = horizontal flip
	db $00,$00,$00,$00		; 80 = vertical flip
	db $00,$00,$00,$00		; C0 = horizontal and vertical flip
	db $00,$00,$00,$00
	db $40,$40,$40,$40
	db $80,$80,$80,$80
	db $80,$80,$80,$80
	db $40,$40,$40,$40
	db $40,$40,$40,$40
	db $40,$40,$40,$40
	db $40,$40,$40,$40
	db $40,$40,$40,$40
	db $00,$00,$00,$00
	db $C0,$C0,$C0,$C0
	db $C0,$C0,$C0,$C0
	
StarSounds:
	db $13,$14,$15,$16,$17,$18,$19

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; init routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Init:
	JSL !SubHorizPos
	TYA
	STA $157C,x
	
	TXA
	AND #$03
	ASL #5
	STA $163E,x
	CLC
	ADC #$32
	STA $1504,x
	
	LDA $7FAB40,x
	PHA
	PHA
	AND #$07
	INC
	STA $1528,x
	PLA
	LSR #4
	STA $160E,x
	PLA
	LSR #2
	AND #$02
	ORA #$0D
	STA $15F6,x
	RTL
	
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; main routine wrapper
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Main:
	JSR MouserMainRt
	RTL

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; main routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

StarKilled:
	INC $1504,x		;
ReturnMain:			;
	RTS				;

MouserMainRt:

	JSR MouserGFX			;
	
	LDA $14C8,x			;
	CMP #$02			;
	BEQ StarKilled			;
	CMP #$08			;
	BNE ReturnMain		;
	LDA $9D				;
	BNE ReturnMain		;
	
	JSL !SubOffscreenX3	;
	
	INC $1570,x			;
	LDA $1504,x			;
	BEQ $03				;
	DEC $1504,x			;
	LDA $1564,x			;
	BEQ $03				;
	DEC $1564,x			;
	
	LDA $151C,x			;
	LSR					;
	BCC .Label1			;
	LDA $1570,x			;
	LSR #3				;
	AND #$01			;
	BRA .Label2			;
.Label1					;
	LDA $151C,x			;
	BEQ .Label2			;
	LDA #$01			;
.Label2					;
	STA $1602,x			;
	
	LDA $1504,x			;
	CMP #!TimeToShow	;
	BCS .Jump				;
	INC $1602,x			;
	INC $1602,x			;
	LDA $1564,x			;
	BNE .SetThrowTimer	;
	LDA $1504,x			;
	BNE .NoReset			;
.SetThrowTimer			;
	LDA #!TimeTillThrow	;
	STA $1504,x			;
.NoReset					;
	CMP #$01			;
	BNE .Jump			;
	LDA $C2,x			;
	EOR #$01				;
	STA $C2,x			;
	JSR SubThrowSprite		;
.Jump					;
	LDA $163E,x			;
	CMP #$28			;
	BCS .Walk				;
	LDA $1564,x			;
	BNE .Walk			;
	LDA $163E,x			;
	CMP #$21			;
	BNE .NoJump2			;
	LDA $1570,x			;
	AND #$02			;
	BEQ .NoJump2			;
	LDA #$C0			;
	STA $AA,x			;
	BRA .ApplySpeed		;
.NoJump2				;
	CMP #$00			;
	BNE .Walk			;
	LDA #$7F				;
	STA $163E,x			;
.Walk					;
	LDA $1564,x			;
	BEQ .WalkNormal		;
	STZ $B6,x			;
	INC $1540,x			;
	BRA .ApplySpeed		;
.WalkNormal				;
	LDY $151C,x			;
	LDA $1540,x			;
	BEQ .ChangeSpeed		;
	LDA XSpeed,y			;
	STA $B6,x			;
	BRA .ApplySpeed		;
.ChangeSpeed				;
	LDA TimeInPos,y		;
	STA $1540,x			;
	LDA $151C,x			;
	INC					;
	AND #$03			;
	STA $151C,x			;
.ApplySpeed				;
	JSL $81802A			;
	LDA $1564,x			;
	BNE .NoBomb			;
	JSR BombInteractRt		;
.NoBomb					;
	LDA $1588,x			;
	AND #$03			;
	BEQ .NoDirChange		;
	LDA $151C,x			;
	INC					;
	AND #$03			;
	STA $151C,x			;
.NoDirChange				;
	JSL $818032			;
	JSL $81A7DC			;
	BCC .NoContact		;
	LDA $1490			;
	BNE .HasStar			;
.NoContact				;
	RTS					;
.HasStar					;
	LDA #$02			;
	STA $14C8,x			;
	STZ $B6,x			;
	LDA #$D0			;
	STA $AA,x			;
	LDA $18D2			;
	CMP #$08			;
	BCC .NoReset2			;
	LDA #$08			;
	STA $18D2			;
.NoReset2				;
	JSL $82ACE5			;
	LDY $18D2			;
	CPY #$08				;
	BCS .NoSound2		;
	LDA StarSounds,y		;
	STY $1DF9			;
.NoSound2				;
	RTS					;

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; graphics routine
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

MouserGFX:

	JSL !GetDrawInfo		;

	LDA $15F6,x			;
	ORA $64				;
	STA $02				;
	LDA $14				;
	LSR					;
	AND #$04			;
	STA $03				;

	PHY					;
	LDY #$00				;
	LDA $14C8,x			;
	CMP #$02			;
	BNE .NoKillFrame		;
	LDY #$18				;
	BRA .Continue			;
.NoKillFrame				;
	LDA $1564,x			;
	BEQ .NoStun			;
	LDY #$10				;
	BRA .Continue			;
.NoStun					;
	LDA $1504,x			;
	CMP #$50			;
	BCC .Continue			;
	LDY #$08				;
.Continue					;
	TYA					;
	CLC					;
	ADC $03				;
	STA $03				;
	PLY					;
	LDA $157C,x			;
	BNE .LoopStart			;
	LDA $03				;
	CLC					;
	ADC #$20			;
	STA $03				;
	
.LoopStart				;
	LDA #$03			;
	STA $04				;
	ORA $03				;
	TAX					;
.Loop					;
	LDA $00				;
	CLC					;
	ADC.w HorizDisp,x		;
	STA $0300,y			;
	
	LDA $01				;
	CLC					;
	ADC.w VertDisp,x		;
	STA $0301,y			;
	
	LDA.w Tilemap,x		;
	STA $0302,y			;
	
	LDA $02				;
	ORA.w TileProps,x		;
	STA $0303,y			;

	INY #4				;
	DEX					;
	DEC $04				;
	BPL .Loop				;
	
	LDX $15E9			;
	LDA $1504,x			; check the throw timer
	CMP #$02			;
	BCC .NoShow			; if 1 < throw timer < 0x1E...
	CMP #$1E			;
	BCS .NoShow			;
	LDA $1602,x			;
	CMP #$02			; and the animation frame is 2 or 3...
	BEQ .ShowProjectile		;
	CMP #$03			; then show the projectile tile as well
	BEQ .ShowProjectile		;
.NoShow					; else, just end the GFX routine here

	LDY #$02				;
	LDA #$03			;
	JSL $81B7B3			; finalize the write to OAM mirrors
	RTS					;

.ShowProjectile			;
	LDA $157C,x			;
	STA $02				;
	PHY					;
	LDY $160E,x			;
	LDA TilesToShow,y		; tile to show
	STA $06				;
	LDA TilePropShow1,y	;
	STA $08				; tile properties 1
	LDA TilePropShow2,y	;
	STA $07				; tile properties 2
	PLY					;

	LDX $02				;
	LDA $00				;
	CLC					;
	ADC.w ProjectileOffset,x	;
	STA $0300,y			;
	
	LDA $01				;
	CLC					;
	ADC #$F2			;
	STA $0301,y			;
	
	LDA $06				;
	STA $0302,y			;
	
	LDA $07,x			;
	ORA $64				;
	STA $0303,y			;
	
	TYA					;
	LSR #2				;
	TAY					;
	LDA #$02			;
	STA $0460,y			;
	
	LDX $15E9			;
	LDY #$02				;
	LDA #$04			;
	JSL $81B7B3			; finalize the write to OAM mirrors
	RTS					;

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;
; subroutines
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;------------------------------------------------
; sprite-spawning routine
;------------------------------------------------

SubThrowSprite:

	LDA $15A0,x			;
	ORA $186C,x			;
	ORA $15D0,x			;
	BNE .Return			;
	
	JSL $82A9E4			;
	BMI .Return			;

	LDA $157C,x			;
	STA $02				;
	
	JSR SpawnShared		;
	
	LDA $01				;
	BMI .SpawnCustom		;
	
	LDA $00				;
	STA $009E,y			;
	
	TYX					;
	JSL $87F7D2			;
	LDY $08				;
	BRA .Shared2			;

.Return					;
	RTS					;

.SpawnCustom				;
	TYX					;
	LDA $00				;
	STA $7FAB9E,x		;
	LDA $01				;
	AND #$83			;
	STA $7FAB10,x		;
	JSL $81830B			;
	LDY $08				;
	LDA SpawnExByte1,y	;
	STA $7FAB40,x		;
	LDA SpawnExByte2,y	;
	STA $7FAB4C,x		;
	LDA SpawnExByte3,y	;
	STA $7FAB58,x		;
	LDA SpawnExByte4,y	;
	STA $7FAB64,x		;
	
.Shared2					;
	LDA SpawnXSpeed,y	;
	STA $B6,x			;
	LDA SpawnYSpeed,y	;
	STA $AA,x			;
	LDA SpawnState1,y		;
	STA $C2,x			;
	LDA SpawnState2,y		;
	STA $1510,x			;
	LDA SpawnTimer1,y	;
	STA $1540,x			;
	LDA SpawnTimer2,y	;
	STA $1504,x			;
	LDA $02				;
	STA $157C,x			;
	BEQ .NoInvertSpeed		;
	LDA $B6,x			;
	EOR #$FF				;
	INC					;
	STA $B6,x			;
.NoInvertSpeed			;
	LDX $15E9			;
	RTS					;

SpawnShared:
	PHY					;
	LDY $157C,x			;
	LDA $E4,x			;
	CLC					;
	ADC SpawnXOffsetLo,y	;
	PLY					;
	STA $00E4,y			;
	PHY					;
	LDY $157C,x			;
	LDA $14E0,x			;
	ADC SpawnXOffsetHi,y	;
	PLY					;
	STA $14E0,y			;

	LDA $D8,x			;
	SEC					;
	SBC #$0E				;
	STA $00D8,y			;
	LDA $14D4,x			;
	SBC #$00				;
	STA $14D4,y			;
	
	LDA $160E,x			;
	STA $08				;
	TAX					;
	LDA.w SpawnStatus,x	;
	STA $14C8,y			;
	TXA					;
	ASL					;
	TAX					;
	REP #$20				;
	LDA.w SpriteToThrow,x	;
	STA $00				;
	SEP #$20				;
	LDX $08				;

	RTS					;
	
;------------------------------------------------
; explosion proximity check
;------------------------------------------------

BombInteractRt:
	TXA					;
	EOR $14				;
	AND #$03			;
	BNE .Return			;
	LDY #$0B				;
.Loop					;
	LDA $1534,y			;
	BNE .HandleExplode	;
.Next					;
	DEY					;
	BPL .Loop				;
.Return					;
	RTS					;
.HandleExplode			;
	LDA $14C8,y			;
	CMP #$08			;
	BNE .Next			;
	LDA $00E4,y			;
	SEC					;
	SBC #$1A				;
	STA $00				;
	LDA $14E0,y			;
	SBC #$00				;
	STA $08				;
	LDA #$44			;
	STA $02				;
	STA $03				;
	LDA $00D8,y			;
	SEC					;
	SBC #$1A				;
	STA $01				;
	LDA $14D4,y			;
	SBC #$00				;
	STA $09				;
	JSL $83B69F			;
	JSL $83B72B			;
	BCC .Next			;
	LDA #$A0			;
	STA $1564,x			;
	LDA #$28			;
	STA $1DFC			;
	DEC $1528,x			;
	BNE .Return			;
	LDA #$02			;
	STA $14C8,x			;
	STZ $B6,x			;
	LDA #$F0				;
	STA $AA,x			;
	RTS					;

;------------------------------------------------
; init and main pointers
;------------------------------------------------

dl Init,Main

